# lightNLP, 很基础的自然语言处理框架

## 简介

本项目基于Pytorch和torchtext，旨在提供一个基础的自然语言处理相关任务实现的深度学习框架。

有关详细说明和教程请参阅项目文档：[lightnlp-cookbook](https://lightnlp-cookbook.readthedocs.io/zh_CN/latest/index.html)

## 声明

1. 本项目从定位上来说只是一次收集和尝试，目的并不作为企业级和生产级使用，目标群体主要是对自然语言处理各任务实践感兴趣的其他方向计算机开发人员以及初学者，更主要的是**自娱自乐**。
2. 若有真正场景需求的用户或开发人员们可以参考[Industry 中文NLP商业服务](https://github.com/crownpku/Awesome-Chinese-NLP#industry-%E4%B8%AD%E6%96%87nlp%E5%95%86%E4%B8%9A%E6%9C%8D%E5%8A%A1)寻求商业服务，当然本渣也乐意提供有偿服务。
3. 本项目并未像其他一些框架一样为各任务提供了一些训练数据和训练好的模型从而可以直接下载使用。
4. 本项目的诸多模型许多都是参考Github上原有实现，然后在基础之上二次加工而成，在这里要向相关作者致以诚挚的谢意！
5. 未对各任务模型的各种参数进行精细微调，仅仅只是能跑通的程度。
6. 本项目仅在以下本人两种开发环境下能跑通，其他环境出现的各种问题本人概不负责。
   - Windows 10， Python 3.6，Pytorch 1.3
   - Manjaro， Python 3.7，Pytorch 1.3

## 安装

```bash
pip install lightNLP
```

建议使用国内源来安装，如使用以下命令：
```bash
pip install -i https://pypi.douban.com/simple/ lightNLP
```

### 安装依赖

由于有些库如pytorch、torchtext并不在pypi源中或者里面只有比较老旧的版本，我们需要单独安装一些库。
#### 安装pytorch

请使用最新版本的Pytorch！

具体安装参见[pytorch官网](https://pytorch.org/get-started/locally/)来根据平台、安装方式、Python版本、CUDA版本来选择适合自己的版本。

#### 安装torchtext

使用以下命令安装最新版本torchtext：
```bash
pip install https://github.com/pytorch/text/archive/master.zip
```

## todo

### 业务

- [x] 增加项目简要说明文档
- [x] 提供各任务Demo训练数据

### 工程

- [x] 重构项目结构，将相同冗余的地方合并起来，保持项目结构清晰
- [x] 增加TensorBoard可视化功能，主要包含如loss和score的`scalar`和以及各model的`graph`（目前Pytorch中的SummaryWriter的add_graph功能有一些bug，所以暂时添加不了了。）。
- [x] 增加简易的基于flask的模型部署功能（当前仅用于模型的训练效果测试）
- [x] 现在模型保存的路径和名字默认一致，会冲突，接下来每个模型都有自己的`name`。
- [ ] 增加断点重训功能。
- [ ] 增加earlyStopping。

### 功能

- [x] 增加CBOW词向量相关模型以及训练预测代码
- [x] 增加skip_gram相关模型以及训练预测代码
- [x] 增加情感分析相关模型以及训练预测代码
- [x] 增加文本蕴含相关模型以及训练预测代码
- [x] 增加文本生成相关模型以及训练预测代码
- [x] 增加语言模型相关模型以及训练预测代码
- [x] 增加依存分析相关模型以及训练预测代码
- [x] 增加关系抽取相关模型以及训练预测代码
- [x] 增加中文分词相关模型以及训练预测代码
- [x] 增加词性标注相关模型以及训练预测代码
- [x] 增加事件抽取相关模型以及训练预测代码
- [x] 增加自动摘要相关模型以及训练预测代码 
- [x] 增加机器翻译相关模型以及训练预测代码 
- [x] 增加句子相似度相关模型以及训练预测代码
- [x] 增加序列到序列相关模型以及训练预测代码
- [x] 增加聊天机器人相关模型以及训练预测代码
- [x] 增加命名实体识别相关模型以及预测训练代码
- [ ] 增加一些任务的transformer实现（基于Pytorch官方实现的Transformer）
- [ ] 增加Elmo相关模型以及训练预测代码
- [ ] 增加GloVe相关模型以及训练预测代码
- [ ] 增加GPT相关模型以及训练预测代码
- [ ] 增加Bert相关模型以及训练预测代码
- [ ] 增加属性抽取相关模型以及训练预测代码
- [ ] 增加指代消解相关模型以及训练预测代码
- [ ] 增加词义消歧相关模型以及训练预测代码
- [ ] 增加阅读理解相关模型以及训练预测代码
- [ ] 增加关键词抽取相关模型以及训练预测代码
- [ ] 增加成分句法分析相关模型以及预测训练代码
